import os
from db import db_hanlder
from lib import common

func_dic = {}
login_user = None


@common.function_choice(func_dic, '注册')
def register():
    print("注册功能正在执行".center(50, '-'))
    username = input("please input your username>>:").strip()
    res = db_hanlder.select(username)
    if res:
        print("对不起, 该用户已经注册过了")
        return

    password = input("please input your password>>:").strip()
    confirm_password = input("please again confirm your password>>:").strip()
    if '' in [username, password]:
        print("对不起, 以上输入内容不能有空")
        return
    if password == confirm_password:
        db_hanlder.save(username, password)
        print("注册成功!!!")
    else:
        print("对不起, 2次密码不一致")


@common.function_choice(func_dic, '登录')
def login():
    print("登录功能正在执行".center(50, '-'))
    username = input("please input your username>>:").strip()
    res = db_hanlder.select(username)
    if not res:
        print("对不起, 登录失败")
        return

    password = input("please input your password>>:").strip()
    if password == res[1]:
        print("登录成功!!!")
        global login_user
        login_user = username
    else:
        print("对不起, 登录失败")


@common.function_choice(func_dic, '充值')
@common.auth
@common.logger
def recharge():
    print("充值功能正在执行".center(50, '-'))
    add_money = input("输入充值金额>>:").strip()
    if not add_money.isdigit():
        print("请输入整数数字")
        return
    add_money = int(add_money)
    db_hanlder.update(login_user, add_money, action='add')
    return login_user, add_money, '充值'


@common.function_choice(func_dic, '阅读')
@common.auth
@common.logger
def reader():
    print("阅读功能正在执行".center(50, '-'))
    while True:
        common.print_story_type()
        choice = input("[返回上一层: B/b]根据编号选择相应的小说类型>>:").strip()
        if choice.lower() == 'b':
            break
        story_type_dic = db_hanlder.get_story_type()
        if choice not in story_type_dic:
            print("对不起, 你输入内容不在其中")
            continue

        # {'0': ['倚天屠狗记.txt', 3], '1': ['沙雕英雄转.txt', 10]}
        fictions_dic = story_type_dic[choice]
        for key, value in fictions_dic.items():
            print(f'编号:{key} 小说:{value[0].split(".")[0]}  价格:{value[1]}元')
        choice1 = input("[返回上一层: B/b]根据编号选择相应的小说>>:").strip()
        if choice.lower() == 'b':
            break
        if choice1 not in fictions_dic:
            print("对不起, 你输入内容不在其中")
            continue

        # ['倚天屠狗记.txt', 3]
        fiction_name, fiction_price = fictions_dic[choice1]
        choice3 = input("是否付费观看Y/y:").strip()
        if choice3.lower() == 'y':
            balance = db_hanlder.select(login_user)[-1]
            if balance >= fiction_price:
                db_hanlder.update(login_user, fiction_price, action='minus')
                db_hanlder.read_fiction(choice, fiction_name)
                return login_user, fiction_price, '消费'
            else:
                print("对不起, 余额不够, 请充值. 目前余额:[%s]元" % balance)
        else:
            print("对不起, 需要确认付费才能观看")


@common.function_choice(func_dic, '作者')
@common.auth
def author():
    print("作者功能正在执行".center(50, '-'))
    file_path = input("请输入你要上传的文件路径>>:").strip()
    if not os.path.isfile(file_path):
        print('对不起, 文件路径不存在')
        return

    print("请选择类型编号为你的小说分类")
    common.print_story_type()
    story_number = input("亲输入对应的小说编号>>:").strip()
    story_type_dic = db_hanlder.get_story_type()
    if story_number not in story_type_dic:
        print("对不起, 输入有误")
        return

    fiction_price = input("请为你的小说定价>>:").strip()
    if not fiction_price.isdigit():
        print("对不起, 亲输入整数数字")
        return
    fiction_price = int(fiction_price)
    db_hanlder.update_story_dir(file_path, story_number, fiction_price)
    db_hanlder.upload_story_file(file_path, story_number)


def run():
    while True:
        for key, value in func_dic.items():
            print(f'({key}):{value[0]}', end='  ')
        print()

        choice = input("输入编号操作对应的功能>>:").strip()
        if not choice.isdigit():
            print("请输入整数数字")
            continue
        choice = int(choice)
        if choice not in func_dic:
            print("输入范围超出不存在")
            continue
        func_dic[choice][1]()
