import time
import os
from lib import common
from conf import settings


def select(username):
    if not os.path.isfile(settings.DB_FILE_PATH):
        return

    with open(settings.DB_FILE_PATH, 'rt', encoding='utf-8') as f:
        for line in f:
            res = line.strip()
            if not res:
                continue
            db_name, db_pwd, db_balance = res.split(':')
            if db_name == username:
                return [db_name, db_pwd, int(db_balance)]


def save(username, password):
    with open(settings.DB_FILE_PATH, 'at', encoding='utf-8') as f:
        f.write(f'{username}:{password}:0\n')


def update(username, money, action):
    swap_path = os.path.join(settings.DB_DIR_PATH, 'swap.txt')
    with open(settings.DB_FILE_PATH, 'rt', encoding='utf-8') as f1, \
            open(swap_path, 'wt', encoding='utf-8') as f2:
        for line in f1:
            res = line.strip()
            if not res:
                continue
            db_name, db_pwd, db_balance = res.split(':')
            if db_name == username:
                db_balance = int(db_balance)
                if action == 'add':
                    db_balance += money
                elif action == 'minus':
                    db_balance -= money
            f2.write(f'{db_name}:{db_pwd}:{db_balance}\n')
    os.remove(settings.DB_FILE_PATH)
    os.rename(swap_path, settings.DB_FILE_PATH)


def get_story_type():
    with open(settings.STORY_CLASS_FILE_PATH, 'rt', encoding='utf-8') as f:
        return eval(f.read())


def read_fiction(fiction_number, fiction_name):
    path = os.path.join(settings.FICTION_DIR_PATH, fiction_number, fiction_name)
    with open(path, 'rt', encoding='utf-8') as f:
        for line in f:
            print(line.strip(), end='')
        print()


def update_story_dir(src_file_path, story_number, fiction_price):
    file_name = src_file_path.split(os.sep)[-1]
    swap_file_path = os.path.join(settings.DB_DIR_PATH, 'swap.txt')
    with open(settings.STORY_CLASS_FILE_PATH, 'rt', encoding='utf-8') as f1, \
            open(swap_file_path, 'wt', encoding='utf-8') as f2:
        # {'0': {'0': ['倚天屠狗记.txt', 3], '1': ['沙雕英雄转.txt', 10]}}
        story_type_dic = eval(f1.read())
        # {'0': ['倚天屠狗记.txt', 3], '1': ['沙雕英雄转.txt', 10]}
        max_number = max(story_type_dic[story_number], key=lambda key: int(key))
        max_number = str(int(max_number) + 1)
        story_type_dic[story_number][max_number] = [file_name, fiction_price]
        f2.write(str(story_type_dic))
    os.remove(settings.STORY_CLASS_FILE_PATH)
    os.rename(swap_file_path, settings.STORY_CLASS_FILE_PATH)


def upload_story_file(src_file_path, story_number):
    file_name = src_file_path.split(os.sep)[-1]
    dst_file_path = os.path.join(settings.FICTION_DIR_PATH, story_number, file_name)
    with open(src_file_path, 'rb') as f1, \
            open(dst_file_path, 'wb') as f2:
        print("upload start...")
        recv_size = 0
        total_size = os.path.getsize(src_file_path)
        while recv_size < total_size:
            for line in f1:
                f2.write(line)
                recv_size += len(line)
                percent = recv_size / total_size
                time.sleep(0.2)
                common.progress(percent)
            print()
        print("upload successful...")
