# 06 打印进度条

## 1. 自己写的打印进度条

```python
import time
import random
import requests


def progress_fmt(symbol, percent, width=50):
    if percent > 1:
        percent = 1
    res = '[{:%s}]' % width
    res1 = res.format(int(width * percent) * symbol)
    # 注意: res2 = '\r%s %s%%' % (res1, round(percent, 4) * 100)
    # res2 = '\r%s %d%%' % (res1, int(percent * 100))
    res2 = '\r%s %.2f%%' % (res1, percent * 100)        # 1.使用\r使光标每次都跳到行首
    print(res2, end='')                                 # 2.注意: print有默认换行功能, 使用end=''去掉


# print(progress_fmt('#', 0.2))
# print(progress_fmt('#', 0.7))

def get_url(url):
    def wrapper():
        return requests.get(url).text

    return wrapper


python_html = get_url('https://www.python.org')

recv_size = 0
total_size = len(python_html())

while recv_size < total_size:
    time.sleep(0.001)
    recv_size += random.randint(1, 10)      # 3.使用random模仿不稳定的下载网速
    # recv_size += 20
    # percent = round(recv_size / total_size, 4)
    percent = recv_size / total_size        # 4.使用每次增加的值除以下载总量, 用来作覆盖操作
    progress_fmt('#', percent)
```

## 2. 老师写的打印进度条

```python
def progress(percent, width=50):
    if percent > 1:
        percent = 1
    show_str = ('[%%-%ds]' % width) % (int(width * percent) * '#')
    print('\r%s %d%%' % (show_str, int(100 * percent)), end='')


import time

recv_size = 0
total_size = 8097
while recv_size < total_size:
    time.sleep(0.1)
    recv_size += 8096
    percent = recv_size / total_size
    progress(percent)
```