import time
from functools import wraps
from conf import settings


def function_choice(function_dic, description):
    def deco(func):
        if not function_dic:
            function_dic[0] = (description, func)
        else:
            function_dic[max(function_dic) + 1] = (description, func)

        @wraps(func)
        def wrapper(*args, **kwargs):
            res = func(*args, **kwargs)
            return res

        return wrapper

    return deco


def auth(func):
    from core import main

    @wraps(func)
    def wrapper(*args, **kwargs):
        if main.login_user:
            res = func(*args, **kwargs)
            return res
        main.login()

        if main.login_user:
            res = func(*args, **kwargs)
            return res

    return wrapper


def logger(func):
    def wrapper(*args, **kwargs):
        res = func(*args, **kwargs)
        if res:
            login_user, money, description = res
            with open(settings.LOG_FILE_PATH, 'at', encoding='utf-8') as f:
                msg = f'时间:{time.strftime("%Y-%m-%d %X")} 用户名{login_user} {description}金额:{money}元'.center(100, '-')
                print(msg)
                f.write(msg + '\n')
        return res

    return wrapper


def print_story_type():
    print("""
        0 玄幻武侠
        1 都市爱情
        2 高效养猪36技
        """)


def progress(percent, symbol='#', width=50):
    if percent > 1:
        percent = 1
    res = '[{:%s}]' % width
    res1 = res.format(int(percent * width) * symbol)
    res2 = '\r%s %.2f%%' % (res1, percent * 100)
    print(res2, end='')
